﻿using System;
using System.Data;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.Web.Mvc;
using System.Web.Caching;

namespace MVCWebApps
{
    public class CacheFilterAttribute : ActionFilterAttribute
    {
        private int _duration;

        public int Duration
        {
            get { return _duration; }
            set { _duration = value; } 
        }

        public CacheFilterAttribute(int duration)
        {
            _duration = duration; 
        }

        public override void OnActionExecuted(FilterExecutedContext filterContext)
        {
            HttpCachePolicyBase cache = filterContext.HttpContext.Response.Cache;

            TimeSpan cacheDuration = TimeSpan.FromSeconds(Duration);

            cache.SetMaxAge(cacheDuration); 
            cache.SetExpires(DateTime.Now.Add(cacheDuration)); 
            cache.SetCacheability(HttpCacheability.Public);
            cache.AppendCacheExtension("must-revalidate, proxy-revalidate");                     
        }
    }
}
